"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.list = {
    signature: 'settings',
    description: 'print current settings',
    help: `\
Use this command to display detected settings

Examples:

	$ resin settings\
`,
    action(_params, _options, done) {
        return __awaiter(this, void 0, void 0, function* () {
            const resin = (yield Promise.resolve().then(() => require('resin-sdk'))).fromSharedOptions();
            const prettyjson = yield Promise.resolve().then(() => require('prettyjson'));
            return resin.settings
                .getAll()
                .then(prettyjson.render)
                .then(console.log)
                .nodeify(done);
        });
    },
};
//# sourceMappingURL=settings.js.map