"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const typed_error_1 = require("typed-error");
class BuildError extends typed_error_1.TypedError {
    constructor(failures) {
        super('Build error');
        this.failures = failures;
    }
    toString() {
        let str = 'Some services failed to build:\n';
        _.each(this.failures, failure => {
            str += `\t${failure.serviceName}: ${failure.error.message}\n`;
        });
        return str;
    }
}
exports.BuildError = BuildError;
class DeviceAPIError extends typed_error_1.TypedError {
}
exports.DeviceAPIError = DeviceAPIError;
class BadRequestDeviceAPIError extends DeviceAPIError {
}
exports.BadRequestDeviceAPIError = BadRequestDeviceAPIError;
class ServiceUnavailableAPIError extends DeviceAPIError {
}
exports.ServiceUnavailableAPIError = ServiceUnavailableAPIError;
//# sourceMappingURL=errors.js.map