"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const child_process_1 = require("child_process");
const Bluebird = require("bluebird");
const rindle = require("rindle");
function executeWithPrivileges(command, stderr) {
    return __awaiter(this, void 0, void 0, function* () {
        const opts = {
            stdio: ['inherit', 'inherit', stderr ? 'pipe' : 'inherit'],
            env: process.env,
        };
        const args = process.argv
            .slice(0, 2)
            .concat(['internal', 'sudo', command.join(' ')]);
        const ps = child_process_1.spawn(args[0], args.slice(1), opts);
        if (stderr) {
            ps.stderr.pipe(stderr);
        }
        return Bluebird.fromCallback(resolver => rindle.wait(ps, resolver));
    });
}
exports.executeWithPrivileges = executeWithPrivileges;
//# sourceMappingURL=sudo.js.map